package com.hand.app.chat.controllers;

import com.codahale.metrics.annotation.Timed;
import com.hand.app.chat.dto.ChatMessage;
import com.hand.app.chat.service.IChatMessageService;
import com.hand.hap.system.controllers.BaseController;
import com.hand.hap.system.dto.ResponseData;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;

/**
 * Created by JS on 2018/7/19.
 */
@Controller
@RequestMapping(value = "/r/api")
public class ChatMessageController extends BaseController {

    @Autowired
    IChatMessageService chatMessageService;

    @RequestMapping(value = "/app/addChatMessage", method = RequestMethod.POST)
    @ResponseBody
    @Timed
    public ChatMessage addMessage(HttpServletRequest request, @RequestBody ChatMessage message) {
        return chatMessageService.insertSelective(createRequestContext(request), message);
    }

    @RequestMapping(value="/app/queryMessage",method= RequestMethod.GET)
    @ResponseBody
    @Timed
    public ResponseData queryMessage(HttpServletRequest request, @RequestParam("host") String host, @RequestParam("guest") String guest){
        return chatMessageService.getMessage(createRequestContext(request),host,guest);
    }
}
