package com.hand.app.electronicSignature.service.impl;


import com.alibaba.fastjson.JSONObject;
import com.hand.app.electronicSignature.dto.EleSignAuth;
import com.hand.app.electronicSignature.service.IElectronicSignatureAuth;
import com.hand.hap.system.service.impl.BaseServiceImpl;
import constant.APIToolKitException;
import org.springframework.stereotype.Service;
import request.Tx1007Request;
import request.Tx1008Request;
import request.Tx1009Request;
import request.Tx8001Request;
import service.SignAPI;
import util.StringUtil;

@Service
public class ElectronicSignatureAuthImpl extends BaseServiceImpl<EleSignAuth> implements IElectronicSignatureAuth {

    //（1007发送授权码）
    public JSONObject postAuthCode(EleSignAuth param) throws Exception {
        JSONObject returnJson = new JSONObject();
        try {
            Tx1007Request tx1007Request = new Tx1007Request();
            tx1007Request.setUserId(param.getUserId());
            tx1007Request.setSerialNumber(param.getSerialNumber());
            String response = SignAPI.sendMessageAndGetResult(tx1007Request);
            returnJson.put("ResponseCode", StringUtil.getNodeText(response, "ResponseCode"));
            returnJson.put("ResponseDesc", StringUtil.getNodeText(response, "ResponseDesc"));
            returnJson.put("txId", StringUtil.getNodeText(response, "TxID"));
        } catch (APIToolKitException e) {
            e.printStackTrace();
        }
        return returnJson;
    }

    //（1008验证授权码）
    public JSONObject verifyAuthCode(EleSignAuth param) throws Exception {
        JSONObject returnJson = new JSONObject();
        try {
            Tx1008Request tx1008Request = new Tx1008Request();
            tx1008Request.setUserId(param.getUserId());
            tx1008Request.setSerialNumber(param.getSerialNumber());
            tx1008Request.setAuthCode(param.getAuthCode());
            String response = SignAPI.sendMessageAndGetResult(tx1008Request);
            returnJson.put("ResponseCode", StringUtil.getNodeText(response, "ResponseCode"));
            returnJson.put("ResponseDesc", StringUtil.getNodeText(response, "ResponseDesc"));
            returnJson.put("txId", StringUtil.getNodeText(response, "TxID"));
        } catch (APIToolKitException e) {
            e.printStackTrace();
        }
        return returnJson;
    }

    //（1009人脸授权）
    public JSONObject faceAuth(JSONObject param) throws Exception {
        JSONObject returnJson = new JSONObject();
        try {
            Tx1009Request tx1009Request = new Tx1009Request();
            tx1009Request.setUserId(param.getString("userId"));
            tx1009Request.setSerialNumber(param.getString("serialNumber"));
            tx1009Request.setImageData(param.getString("selfieData"));
            String response = SignAPI.sendMessageAndGetResult(tx1009Request);
            returnJson.put("ResponseCode", StringUtil.getNodeText(response, "ResponseCode"));
            returnJson.put("ResponseDesc", StringUtil.getNodeText(response, "ResponseDesc"));
            returnJson.put("txId", StringUtil.getNodeText(response, "TxID"));
        } catch (APIToolKitException e) {
            e.printStackTrace();
        }
        return returnJson;
    }

    //8001查询授权码
    public JSONObject queryAuthCode(EleSignAuth param) throws Exception {
        JSONObject returnJson = new JSONObject();
        try {
            Tx8001Request tx8001Request = new Tx8001Request();
            tx8001Request.setUserId(param.getUserId());
            tx8001Request.setSerialNumber(param.getSerialNumber());
            String response = SignAPI.sendMessageAndGetResult(tx8001Request);
            returnJson.put("ResponseCode", StringUtil.getNodeText(response, "ResponseCode"));
            returnJson.put("ResponseDesc", StringUtil.getNodeText(response, "ResponseDesc"));
            returnJson.put("authCode", StringUtil.getNodeText(response, "authCode"));
            returnJson.put("txId", StringUtil.getNodeText(response, "TxID"));
        } catch (APIToolKitException e) {
            e.printStackTrace();
        }
        return returnJson;
    }
}
