package com.hand.app.esignHclc.dto;

import com.hand.app.esign.bean.AttachmentInfo;
import com.hand.hap.mybatis.annotation.ExtensionAttribute;
import com.hand.hap.system.dto.BaseDTO;

import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;

/**
 * Created with IntelliJ IDEA.
 * User: lsy
 * Date: 2020/2/24
 * Time: 9:08
 */
@Table(name = "sign_user_info_hclc")
@ExtensionAttribute(disable = true)
public class SignUserInfoHclc extends BaseDTO {

    @Id
    private String openId;
    private String idNo;//身份证件号（组织机构号）
    private String name;//用户名称（组织机构名称）
    private String mobile;
    private String email;
    private String title;
    private String address;
    private String legalName;//法定代表人姓名
    private Long ctitype;//用户类型(1-个人，2-法人)
    private Long agentType;//经办人类型(1-法定代表人，2-组织其他员工)
    private String agentIdNo;//经办人身份证号码
    private String agentName;//经办人姓名
    private String legalIdNo;//法定代表人身份证号码

    private String accountId; // 用户e签宝账户
    private String agentAccountId; // 经办人e签宝账户

    private String createCode; // e签宝用户创建返回code

    private String createMessage; // e签宝用户创建返回描述

    private Long faceAuthId;//人脸识别流程id

    private Long orgAuthId;//企业识别流程id

    private String authAccountId; // 用户e签宝账户

    private String authAgentAccountId; // 经办人e签宝账户

    private String authFlag; // 用户通过认证状态

    private String dealerFlag; // 是否代理店

    private String sealId; // 是否代理店

    private String isManagerFlag;  // 是否管理员角色

    private String  managerAuthFlag; // 管理员授权状态

    private String openIdNew;

    private String openIdBak;

    @Transient
    private String attachmentId;//身份证附件id

    @Transient
    private String orgAttachmentId;//机构营业执照附件id

    @Transient
    private AttachmentInfo attachmentInfo; // 附件信息

    @Transient
    private String apiUrl; // e签宝接口url

    @Transient
    private String appId; // e签宝人脸接口用户id

    @Transient
    private String secret; // e签宝人脸接口密钥

    @Transient
    private String redirectUrl; // e签宝返回企业认证url

    @Transient
    private String notifyUrl; // e签宝返回企业认证url

    @Transient
    private String faceAuthStatus;//人脸识别流程id

    @Transient
    private String orgAuthStatus;//企业识别流程id

    @Transient
    private String mediaId;//微信图片资源id

    @Transient
    private String historyFlag;//微信图片资源id

    @Transient
    private String oldOpenId;

    public AttachmentInfo getAttachmentInfo() {
        return attachmentInfo;
    }

    public void setAttachmentInfo(AttachmentInfo attachmentInfo) {
        this.attachmentInfo = attachmentInfo;
    }

    public String getApiUrl() {
        return apiUrl;
    }

    public void setApiUrl(String apiUrl) {
        this.apiUrl = apiUrl;
    }

    public String getAppId() {
        return appId;
    }

    public void setAppId(String appId) {
        this.appId = appId;
    }

    public String getSecret() {
        return secret;
    }

    public void setSecret(String secret) {
        this.secret = secret;
    }

    public String getOpenId() {
        return openId;
    }

    public void setOpenId(String openId) {
        this.openId = openId;
    }

    public String getIdNo() {
        return idNo;
    }

    public void setIdNo(String idNo) {
        this.idNo = idNo;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getMobile() {
        return mobile;
    }

    public void setMobile(String mobile) {
        this.mobile = mobile;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public Long getAgentType() {
        return agentType;
    }

    public void setAgentType(Long agentType) {
        this.agentType = agentType;
    }

    public Long getCtitype() {
        return ctitype;
    }

    public void setCtitype(Long ctitype) {
        this.ctitype = ctitype;
    }

    public String getAgentAccountId() {
        return agentAccountId;
    }

    public void setAgentAccountId(String agentAccountId) {
        this.agentAccountId = agentAccountId;
    }

    public String getAgentIdNo() {
        return agentIdNo;
    }

    public void setAgentIdNo(String agentIdNo) {
        this.agentIdNo = agentIdNo;
    }

    public String getAgentName() {
        return agentName;
    }

    public void setAgentName(String agentName) {
        this.agentName = agentName;
    }

    public String getLegalIdNo() {
        return legalIdNo;
    }

    public void setLegalIdNo(String legalIdNo) {
        this.legalIdNo = legalIdNo;
    }

    public String getLegalName() {
        return legalName;
    }

    public void setLegalName(String legalName) {
        this.legalName = legalName;
    }

    public String getAccountId() {
        return accountId;
    }

    public void setAccountId(String accountId) {
        this.accountId = accountId;
    }

    public String getRedirectUrl() {
        return redirectUrl;
    }

    public void setRedirectUrl(String redirectUrl) {
        this.redirectUrl = redirectUrl;
    }

    public String getNotifyUrl() {
        return notifyUrl;
    }

    public void setNotifyUrl(String notifyUrl) {
        this.notifyUrl = notifyUrl;
    }

    public String getAttachmentId() {
        return attachmentId;
    }

    public void setAttachmentId(String attachmentId) {
        this.attachmentId = attachmentId;
    }

    public String getOrgAttachmentId() {
        return orgAttachmentId;
    }

    public void setOrgAttachmentId(String orgAttachmentId) {
        this.orgAttachmentId = orgAttachmentId;
    }

    public String getMediaId() {
        return mediaId;
    }

    public void setMediaId(String mediaId) {
        this.mediaId = mediaId;
    }

    public String getCreateCode() {
        return createCode;
    }

    public void setCreateCode(String createCode) {
        this.createCode = createCode;
    }

    public String getCreateMessage() {
        return createMessage;
    }

    public void setCreateMessage(String createMessage) {
        this.createMessage = createMessage;
    }

    public Long getFaceAuthId() {
        return faceAuthId;
    }

    public void setFaceAuthId(Long faceAuthId) {
        this.faceAuthId = faceAuthId;
    }

    public Long getOrgAuthId() {
        return orgAuthId;
    }

    public void setOrgAuthId(Long orgAuthId) {
        this.orgAuthId = orgAuthId;
    }

    public String getAuthAccountId() {
        return authAccountId;
    }

    public void setAuthAccountId(String authAccountId) {
        this.authAccountId = authAccountId;
    }

    public String getAuthAgentAccountId() {
        return authAgentAccountId;
    }

    public void setAuthAgentAccountId(String authAgentAccountId) {
        this.authAgentAccountId = authAgentAccountId;
    }

    public String getFaceAuthStatus() {
        return faceAuthStatus;
    }

    public void setFaceAuthStatus(String faceAuthStatus) {
        this.faceAuthStatus = faceAuthStatus;
    }

    public String getOrgAuthStatus() {
        return orgAuthStatus;
    }

    public void setOrgAuthStatus(String orgAuthStatus) {
        this.orgAuthStatus = orgAuthStatus;
    }

    public String getAuthFlag() {
        return authFlag;
    }

    public void setAuthFlag(String authFlag) {
        this.authFlag = authFlag;
    }

    public String getDealerFlag() {
        return dealerFlag;
    }

    public void setDealerFlag(String dealerFlag) {
        this.dealerFlag = dealerFlag;
    }

    public String getSealId() {
        return sealId;
    }

    public void setSealId(String sealId) {
        this.sealId = sealId;
    }

    public String getHistoryFlag() {
        return historyFlag;
    }

    public void setHistoryFlag(String historyFlag) {
        this.historyFlag = historyFlag;
    }

    public String getIsManagerFlag() {
        return isManagerFlag;
    }

    public void setIsManagerFlag(String isManagerFlag) {
        this.isManagerFlag = isManagerFlag;
    }

    public String getManagerAuthFlag() {
        return managerAuthFlag;
    }

    public void setManagerAuthFlag(String managerAuthFlag) {
        this.managerAuthFlag = managerAuthFlag;
    }

    public String getOldOpenId() {
        return oldOpenId;
    }

    public void setOldOpenId(String oldOpenId) {
        this.oldOpenId = oldOpenId;
    }

    public String getOpenIdBak() {
        return openIdBak;
    }

    public void setOpenIdBak(String openIdBak) {
        this.openIdBak = openIdBak;
    }

    public String getOpenIdNew() {
        return openIdNew;
    }

    public void setOpenIdNew(String openIdNew) {
        this.openIdNew = openIdNew;
    }
}
