package com.hand.app.hms.controllers;

import com.codahale.metrics.annotation.Timed;
import com.hand.app.hms.dto.HmsThirdpartyApp;
import com.hand.app.hms.service.IHmsThirdpartyAppService;
import com.hand.app.hms.service.IWxService;
import com.hand.hap.intergration.exception.HapApiException;
import com.hand.hap.intergration.service.IHapInterfaceHeaderService;
import com.hand.hap.system.controllers.BaseController;
import net.sf.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;

/**
 * Created by user on 2016/7/27.
 */
@Controller
@RequestMapping(value = "/r/api")
public class HmsWxController extends BaseController {

    private final Logger logger = LoggerFactory.getLogger(HmsWxController.class);
    private final String oppen_id_url = "https://api.weixin.qq.com/sns/jscode2session?appid=APPID&secret=SECRET&js_code=JSCODE&grant_type=authorization_code";

    @Autowired
    IHapInterfaceHeaderService headerService;

    @Autowired
    IHmsThirdpartyAppService HmsThirdpartyAppService;
    @Autowired
    IWxService wxservice;


    @RequestMapping(value = "/app/wxoppenid", method = RequestMethod.POST)
    @ResponseBody
    @Timed
    public JSONObject sentRequest(HttpServletRequest request, @RequestBody(required = false) JSONObject params)
            throws HapApiException {
        JSONObject json = null;
        String AppName = request.getParameter("AppName");
        logger.info("requestBody:{}", params);
        HmsThirdpartyApp HmsThirdparty = HmsThirdpartyAppService.selectByKey(AppName);

        String app_id = HmsThirdparty.getAppKey();
        String app_screct = HmsThirdparty.getAppSecret();
        String url = oppen_id_url.replace("APPID", app_id).replace("SECRET", app_screct).replace("JSCODE", params.getString("code"));
        try {
            json = wxservice.get(url);
        } catch (RuntimeException e) {
            json = new JSONObject();
            json.put("errMsg", e.getMessage());
        }
        return json;
    }
}


