

package com.hand.app.wflSend.service.impl;

import com.hand.app.wflSend.service.IWflMessageSendService;
import com.alibaba.fastjson.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

import java.io.*;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;

@Service
public class WflMessageSendServiceImpl implements IWflMessageSendService {

    private Logger logger = LoggerFactory.getLogger(WflMessageSendServiceImpl.class);
    @Override
    public JSONObject get(String https_url) {
        String resultData = "";
        JSONObject json = null;
        try {
            URL ServiceURL = new URL(https_url);
            HttpURLConnection httpURLConnection = (HttpURLConnection) ServiceURL.openConnection();
            httpURLConnection.setRequestMethod("GET");
            httpURLConnection.setRequestProperty("Content-Type", "application/json");
            //httpURLConnection.setRequestProperty("Accept", headerAndLineDTO.getRequestAccept());
            httpURLConnection.connect();

            if (httpURLConnection.getResponseCode() != 200) {
                throw new RuntimeException("HTTP GET Request Failed with Error code : " + httpURLConnection.getResponseCode());
            }
            BufferedReader reader = new BufferedReader(new InputStreamReader(httpURLConnection.getInputStream(), "utf-8"));
            StringBuilder results = new StringBuilder();
            String line;
            while ((line = reader.readLine()) != null) {
                results.append(line);
            }
            reader.close();
            resultData = results.toString();

            httpURLConnection.disconnect();


        } catch (MalformedURLException e) {
            e.printStackTrace();
            logger.error(e.getMessage());

        } catch (IOException e) {
            e.printStackTrace();
            logger.error(e.getMessage());
        }
        logger.info("responseData:{}", resultData);

        json = JSONObject.parseObject(resultData);
        return json;
    }


}
