package com.hand.hap.core.web.view.ui;

import com.hand.hap.core.web.view.UITag;
import com.hand.hap.core.web.view.ViewContext;
import com.hand.hap.core.web.view.XMap;

/**
 * Created by gaoyang on 17/7/7.
 */
@UITag
public class HlsEditor extends Editor implements HlsComponent{

    public static final String PROPERTITY_HLSEDITOR = "hlsEditor";

    public static HlsEditor createInstance() {
        XMap view = new XMap(DEFAULT_TAG_PREFIX, DEFAULT_NAME_SPACE,
                PROPERTITY_HLSEDITOR);
        HlsEditor hlsEditor = new HlsEditor();
        hlsEditor.initPrototype(view);
        return hlsEditor;
    }

    public void init(XMap view, ViewContext context) throws Exception {
        super.init(view, context);
        context.put(PROPERTITY_PRMOPTIMAGE, getPromptImage());
        context.put(PROPERTITY_PROMPTCOLSPAN, getPromptColspan());
        context.put(PROPERTITY_PROMPT, getPrompt());
        context.put(PROPERTITY_COLSPAN, getColSpan());
        context.put(PROPERTITY_VALIDATIONMESSAGE, getValidationMessage());
        context.put(PROPERTITY_BINDMODEL, getHlsBindModel());
        context.put(PROPERTITY_HLSCLASSNAME, getHlsClassName());
        context.put(PROPERTITY_PROMPTCLASSNAME, getPromptClassName());
    }

    @Override
    public void hlsSetPropertity(Object key, Object value) {
        super.setPropertity(key, value);
    }
}
